;**************************************************************************
;
;                           PVK40 Example : Wire
;
; Processor : PIC18F4520
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on B3 LED on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC18F4520  ; processor type
        __config 0x300001,0x01  ; configuration settings
        __config 0x300002,0x06
        __config 0x300003,0x00
        __config 0x300005,0x85
        __config 0x300006,0x80
        __config 0x300008,0x0F
        __config 0x300009,0xC0
        __config 0x30000A,0x0F
        __config 0x30000B,0xE0
        __config 0x30000C,0x0F
        __config 0x30000D,0x40
;--------------------------------------------------------------------------
; Symbol definition :
portb   equ     0xF81
trisb   equ     0xF93
portd   equ     0xF83
trisd   equ     0xF95
;
#define PB      portd,0         ;pushbutton 0 is on the RD0 pin
#define LED     portb,3         ;LED is on the RB3 pin
; RAM access bit definition :
a       equ     0x00            ;access RAM
banked  equ     0x01            ;bank specified by BSR register
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
        movlw   B'11110111'
        movwf   trisb,a         ;pin RB3 is output
        movlw   B'11111111'
        movwf   trisd,a         ;portd pins are inputs
;
Main:   btfss   PB,a            ;is PB 0 or 1?
        goto    Main_A          ;if PB=0, jump to main_A
        bcf     LED,a           ;PB=1, LED off
        goto    Main            ;closes the loop
Main_A: bsf     LED,a           ;LED on
        goto    Main            ;closes the loop
;**************************************************************************
; end of PVK40 Example : Wire
        end
