;**************************************************************************
;
;                           PVK40 Example : PWM
;
; Processor : PIC16F877A
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on C2 BUZZER on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC16F877A  ; processor type
        __config 0x3F71         ; configuration setting
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P16f877a.INC>
; Bits definition :
#define PB0     portd,0         ;pushbutton 0
#define PB1     portd,1         ;pushbutton 1
#define PB2     portd,2         ;pushbutton 2
#define PB3     portd,3         ;pushbutton 3
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  clrf    ccpr1h          ;PWM duty cycle = 0%
        clrf    ccpr1l
        movlw   B'00001111'     ;CCP1 mode = PWM
        movwf   ccp1con
        clrf    tmr2
        movlw   B'00000100'     ;timer2 on
        movwf   t2con
        bsf     status,RP0      ;bank 1
        movlw   B'11111111'     ;PWM period
        movwf   pr2
        movlw   B'11111011'     ;pin RC2 is output
        movwf   trisc
        bcf     status,RP0      ;bank 0
;
Main:   btfss   PB0             ;test pushbutton 0
        goto    Tone_A
        btfss   PB1             ;test pushbutton 1
        goto    Tone_B
        btfss   PB2             ;test pushbutton 2
        goto    Tone_C
        btfss   PB3             ;test pushbutton 3
        goto    Tone_D
        clrf    ccpr1l          ;none pushbutton is pressed
        bcf     ccp1con,CCP1X   ;PWM duty cycle = 0%
        bcf     ccp1con,CCP1Y
        goto    Main            ;closes the loop
;
Tone_A: bsf     ccp1con,CCP1X   ;PWM duty cycle = 0.2%
        goto    Main            ;closes the loop
Tone_B: movlw   0x04            ;PWM duty cycle = 1.6%
        movwf   ccpr1l
        goto    Main            ;closes the loop
Tone_C: movlw   0x20            ;PWM duty cycle = 12%
        movwf   ccpr1l
        goto    Main            ;closes the loop
Tone_D: movlw   0x80            ;PWM duty cycle = 50%
        movwf   ccpr1l
        goto    Main            ;closes the loop
;**************************************************************************
; end of PVK40 Example : PWM
        end
