;**************************************************************************
;
;                           PVK40 Example : PWM
;
; Processor : PIC18F4520
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on C2 BUZZER on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC18F4520  ; processor type
        __config 0x300001,0x01  ; configuration settings
        __config 0x300002,0x06
        __config 0x300003,0x00
        __config 0x300005,0x85
        __config 0x300006,0x80
        __config 0x300008,0x0F
        __config 0x300009,0xC0
        __config 0x30000A,0x0F
        __config 0x30000B,0xE0
        __config 0x30000C,0x0F
        __config 0x30000D,0x40
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P18f4520.INC>
; Bits definition :
#define PB0     portd,0         ;pushbutton 0
#define PB1     portd,1         ;pushbutton 1
#define PB2     portd,2         ;pushbutton 2
#define PB3     portd,3         ;pushbutton 3
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  clrf    ccpr1h,a        ;PWM duty cycle = 0%
        clrf    ccpr1l,a
        movlw   B'00001100'     ;CCP1 mode = PWM
        movwf   ccp1con,a
        clrf    tmr2,a
        movlw   B'00000100'     ;timer2 on
        movwf   t2con,a
        movlw   B'11111111'     ;PWM period
        movwf   pr2,a
        movlw   B'11111011'     ;pin RC2 is output
        movwf   trisc,a
;
Main:   btfss   PB0,a           ;test pushbutton 0
        bra     Tone_A
        btfss   PB1,a           ;test pushbutton 1
        bra     Tone_B
        btfss   PB2,a           ;test pushbutton 2
        bra     Tone_C
        btfss   PB3,a           ;test pushbutton 3
        bra     Tone_D
        clrf    ccpr1l,a        ;none pushbutton is pressed
        bcf     ccp1con,DC1B1,a ;PWM duty cycle = 0%
        bcf     ccp1con,DC1B0,a
        goto    Main            ;closes the loop
;
Tone_A: bsf     ccp1con,DC1B1,a ;PWM duty cycle = 0.2%
        goto    Main            ;closes the loop
Tone_B: movlw   0x04            ;PWM duty cycle = 1.6%
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
Tone_C: movlw   0x20            ;PWM duty cycle = 12%
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
Tone_D: movlw   0x80            ;PWM duty cycle = 50%
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;**************************************************************************
; end of PVK40 Example : PWM
        end
