;**************************************************************************
;
;                           PVK40 Example : Piano
;
; Processor : PIC16F877A
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on C2 BUZZER on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC16F877A  ; processor type
        __config 0x3F71         ; configuration setting
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P16f877a.INC>
; Bits definition :
#define PB0     portd,0         ;pushbutton 0
#define PB1     portd,1         ;pushbutton 1
#define PB2     portd,2         ;pushbutton 2
#define PB3     portd,3         ;pushbutton 3
#define PB4     portd,4         ;pushbutton 4
#define PB5     portd,5         ;pushbutton 5
#define PB6     portd,6         ;pushbutton 6
#define PB7     portd,7         ;pushbutton 7
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  clrf    ccpr1h          ;PWM duty cycle = 0%
        clrf    ccpr1l
        movlw   B'00001111'     ;CCP1 mode = PWM
        movwf   ccp1con
        clrf    tmr2
        movlw   B'00000111'     ;timer2 on, prescaler 1:16
        movwf   t2con
        bsf     status,RP0      ;bank 1
        movlw   B'11111011'     ;pin RC2 is output
        movwf   trisc
        bcf     status,RP0      ;bank 0
;
Main:   btfss   PB0             ;test pushbutton 0
        goto    T_c2
        btfss   PB1             ;test pushbutton 1
        goto    T_d2
        btfss   PB2             ;test pushbutton 2
        goto    T_e2
        btfss   PB3             ;test pushbutton 3
        goto    T_f2
        btfss   PB4             ;test pushbutton 4
        goto    T_g2
        btfss   PB5             ;test pushbutton 5
        goto    T_a2
        btfss   PB6             ;test pushbutton 6
        goto    T_h2
        btfss   PB7             ;test pushbutton 7
        goto    T_c3
        clrf    ccpr1l          ;none pushbutton is pressed
        goto    Main            ;closes the loop
;
T_c2:   bsf     status,RP0      ;bank 1
        movlw   0x61            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x05            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_d2:   bsf     status,RP0      ;bank 1
        movlw   0x56            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x04            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_e2:   bsf     status,RP0      ;bank 1
        movlw   0x4D            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x04            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_f2:   bsf     status,RP0      ;bank 1
        movlw   0x48            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x04            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_g2:   bsf     status,RP0      ;bank 1
        movlw   0x40            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x03            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_a2:   bsf     status,RP0      ;bank 1
        movlw   0x39            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x03            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_h2:   bsf     status,RP0      ;bank 1
        movlw   0x33            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x03            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;
T_c3:   bsf     status,RP0      ;bank 1
        movlw   0x30            ;setup PWM frequency
        movwf   pr2
        bcf     status,RP0      ;bank 0
        movlw   0x02            ;PWM duty cycle
        movwf   ccpr1l
        goto    Main            ;closes the loop
;**************************************************************************
; end of PVK40 Example : Piano
        end
