/*============================================================================

     lcd.h - header file for LCD module MC1602

 Board : PVK40
 Processor : PIC16F877A
 Clock : XT 3.2768 MHz

============================================================================*/

#ifndef lcdH
#define lcdH

#define DISPLAY_ONOFF 4
#define CURSOR_ONOFF 3
#define CURSOR_LINE  2
#define CURSOR_BLINK 1

/* display command macros */
#define DisplayClear()     DispWrByte(0x01,0,2000)
#define DisplayRetHome()   DispWrByte(0x02,0,2000)
#define DisplayOnOff(x)    DispWrByte(0x08|(x),0,50)
#define DisplayDRAdr(x)    DispWrByte(0x80|(x),0,50)
#define DisplayCRAdr(x)    DispWrByte(0x40|(x),0,50)
#define DisplayWrData(x)   DispWrByte(x,1,50)

extern void DispWrByte(unsigned char c, unsigned char isdata, unsigned short delay_us);
extern void DispHwInit(void);

#endif
